local LDB

local menu = {}
local startChar = {
	["AB"] = {
	},
	["CD"] = {
	},
	["EF"] = {
	},
	["GH"] = {
	},
	["IJ"] = {
	},
	["KL"] = {
	},
	["MN"] = {
	},
	["OP"] = {
	},
	["QR"] = {
	},
	["ST"] = {
	},
	["UV"] = {
	},
	["WX"] = {
	},
	["YZ"] = {
	}
}


local parent = CreateFrame('Frame')
local function pairsByKeys (startChar, f)
	local a = {}
		for n in pairs(startChar) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], startChar[a[i]]
			end
		end
	return iter
end


local function UpdateDisplay()
local numPets, numOwned = C_PetJournal.GetNumPets(false);	
	if lastpetIndex ~= nil then
		LDB.text = lastpetText
		LDB.icon = lastpetIcon
		--local speciesID, customName, level, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petID)
		local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(lastpetIndex)
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", lastpetIndex)
		local creatureName = name
		if customName then
			creatureName = customName
		end
		
		if creatureName ~= lastpetText then
			for i = 1, numOwned do
			local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			if creatureName == lastpetText then
				lastpetIndex = petID
			end
			end
		end
	end
	
	if fav1index ~= nil  then
		--local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(fav1index)
		local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav1index)
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav1index)
		local creatureName = petName
		if customName then
			creatureName = customName
		end
		if creatureName ~= fav1name then
			for i = 1, numOwned do
			local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			local creatureName = name
			if customName then
				creatureName = customName
			end
			if creatureName == fav1name then
				fav1index = petID
			end
			end
		end
	end
	if fav2index ~= nil  then
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav2index)
		--local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(fav2index)
		local speciesID, customName, level, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav2index)
		local creatureName = petName
			if customName then
				creatureName = customName
			end
		if creatureName ~= fav2name then
			for i = 1, numOwned do
			--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			local creatureName = name
			if customName then
				creatureName = customName
			end
			if creatureName == fav2name then
				fav2index = petID
			end
			end
		end
	end
	if fav3index ~= nil  then
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav3index)
		--local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(fav3index)
		local speciesID, customName, level, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav3index)
		local creatureName = petName
			if customName then
				creatureName = customName
			end
		if creatureName ~= fav3name then
			for i = 1, numOwned do
			--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
			local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			creatureName = name
			if customName then
				creatureName = customName
			end
			if creatureName == fav3name then
				fav3index = petID
			end
			end
		end
	end
	
	--for i = 1, numOwned do
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		local summonedPetID = C_PetJournal.GetSummonedPetID();
		
		if summonedPetID then
		local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(summonedPetID)
		local creatureName = petName
			if customName then
				creatureName = customName
			end
			if creatureName then
			LDB.text = format("|cff00ff00%s|r", creatureName)
			LDB.icon = petIcon
			lastpetText = creatureName
			lastpetIndex = summonedPetID
			lastpetIcon = petIcon
			return
			end
		end
	--end
end

local function ModifiedClick(button, Id)	
--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
--local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(Id)
	local creatureName = petName
		if customName then
			creatureName = customName
		end
	
	if IsShiftKeyDown() then
		--PickupCompanion("CRITTER", i)
		C_PetJournal.PickupPet(petID, isWildPet);
	elseif IsAltKeyDown() and not IsControlKeyDown() then
		fav1index = Id
		fav1name = creatureName
		fav1icon = petIcon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		fav2index = Id
		fav2name = creatureName
		fav2icon = petIcon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		fav3index = Id
		fav3name = creatureName
		fav3icon = petIcon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r %s added as favorite 3.", creatureName))
	else
		--CallCompanion("CRITTER", i)
		C_PetJournal.SummonPetByID(Id);
	end
end

local function OnTooltipShow(self)
	local numPets, numOwned = C_PetJournal.GetNumPets(false);
	self:AddLine('|cff00ffffBrokerPets|r')
	self:AddLine("<Right Click> to open pet list")
	self:AddLine("<Left Click> to summon/dismiss pet")
	self:AddLine("<Shift-Left Click> plugin to summon a random pet")
	self:AddLine("<Shift-Left Click> pet to pick it up")
	self:AddLine("<ALT-Click> pet to set as favorite 1")
	self:AddLine("<CTRL-Click> pet to set as favorite 2")
	self:AddLine("<CTRL-ALT-Click> pet to set as favorite 3")
	if numOwned == 0 then
	self:AddLine("|cffff0000You have no pets|r")
	else
	self:AddLine(string.format("|cff00ff00You have %s pets|r", numOwned))
	end
end

local function OnClick(self, button)
	if (button == 'RightButton') then
		ToggleDropDownMenu(1, nil, parent, self, 0, 0)
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r menu toggled"))
	end
	if (IsShiftKeyDown() and button == 'LeftButton') then	
		SummonRandomCritter()
	end
	if (button == 'LeftButton' and not IsShiftKeyDown()) then	
		if lastpetIndex ~= nil then
			--CallCompanion("CRITTER", lastpetIndex)
			C_PetJournal.SummonPetByID(lastpetIndex);
		end
	end	
end

local function CreateMenu(self, level)
	local numPets, numOwned = C_PetJournal.GetNumPets(false);
	menu = wipe(menu)
	local firstChar
	if 	numOwned <= 20 then
	for i = 1, numOwned do
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
		--local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local creatureName = petName
		if customName then
			creatureName = customName
		end
		local isSummonable = C_PetJournal.PetIsSummonable(PetID)
		--local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", i)
		menu.text = creatureName
		menu.func = ModifiedClick
		menu.arg1 = petID
		menu.notCheckable = 1
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		if not isSummonable then
			menu.colorCode = "|cff848484"
		end
		--[[if duration > 1.5 then
			cooldown = floor(((startTime + duration) - GetTime()) / 60)
			cd = format("%d m", cooldown)
			if cooldown >= 60 then
				cd = format("%.1f h", (cooldown / 60))
			end
			menu.text = string.format('%s (%s)', creatureName, cd)
			menu.colorCode = "|cff848484"
		end]]
		local summonedPetID = C_PetJournal.GetSummonedPetID();
		if summonedPetID == petID then
			menu.colorCode = "|cff00ff00"
		end
		UIDropDownMenu_AddButton(menu)
	end
	elseif numOwned >= 21 then
	level = level or 1;
	if (level == 1) then
	for key, v in pairsByKeys(startChar) do
		menu.text = key
		menu.notCheckable = 1
		menu.hasArrow = true;
		menu.value = {
			["Level1_Key"] = key;
		};
	
		UIDropDownMenu_AddButton(menu, level)
	end
		if fav1index ~= nil then
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav1index)
		--local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav1index)
			local creatureName = petName
			if customName then
				creatureName = customName
			end
		--local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local isSummonable = C_PetJournal.PetIsSummonable(fav1index)
		--local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav1index)	
			menu.text = format ("1. %s", fav1name)
			menu.icon = fav1icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav1index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isSummonable then
				menu.colorCode = "|cff848484"
			end
			--[[if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('1. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end]]
			local summonedPetID = C_PetJournal.GetSummonedPetID();
			if summonedPetID == fav1index then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if fav2index ~= nil then
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav2index)
		local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav2index)
			local creatureName = petName
			if customName then
				creatureName = customName
			end
		--local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local isSummonable = C_PetJournal.PetIsSummonable(fav2index)
		--local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav2index)	
			menu.text = format("2. %s", fav2name)
			menu.icon = fav2icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav2index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isSummonable then
				menu.colorCode = "|cff848484"
			end
			--[[if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('2. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end]]
			local summonedPetID = C_PetJournal.GetSummonedPetID();
			if summonedPetID == fav2index then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if fav3index ~= nil then
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", fav3index)
		local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav3index)
			local creatureName = petName
			if customName then
				creatureName = customName
			end
		--local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local isSummonable = C_PetJournal.PetIsSummonable(fav3index)
		--local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", fav3index)	
			menu.text = format("3. %s", fav3name)
			menu.icon = fav3icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = fav3index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isSummonable then
				menu.colorCode = "|cff848484"
			end
			--[[if duration > 1.5 then
				cooldown = floor(((startTime + duration) - GetTime()) / 60)
				cd = format("%d m", cooldown)
				if cooldown >= 60 then
					cd = format("%.1f h", (cooldown / 60))
				end
				menu.text = string.format('3. %s (%s)', creatureName, cd)
				menu.colorCode = "|cff848484"
			end]]
			local summonedPetID = C_PetJournal.GetSummonedPetID();
			if summonedPetID == fav3index then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
	end
	if (level == 2) then
	 -- getting values of first menu
    local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
		
    for i = 1, numOwned do
		
		--local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", i)
		--local speciesID, customName, level, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(fav3index)
		local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			local creatureName = name
			if customName then
				creatureName = customName
			end
		--local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local isSummonable = C_PetJournal.PetIsSummonable(petID)
		--local startTime, duration, isEnabled = GetCompanionCooldown("CRITTER", i)
		firstChar = strupper(strsub(creatureName, 1, 1))

		menu.hasArrow = false; -- Start menu creation
		menu.notCheckable = true;
		menu.text = creatureName
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		menu.func = ModifiedClick
		menu.arg1 = petID
		
		if not isSummonable then
			menu.colorCode = "|cff848484"
		end
		--[[if duration > 1.5 then
			cooldown = floor(((startTime + duration) - GetTime()) / 60)
			cd = format("%d m", cooldown)
			if cooldown >= 60 then
				cd = format("%.1f h", (cooldown / 60))
			end
			menu.text = string.format('%s (%s)', creatureName, cd)
			menu.colorCode = "|cff848484"
		end]]
		local summonedPetID = C_PetJournal.GetSummonedPetID();
		if summonedPetID == petID then
			menu.colorCode = "|cff00ff00"
		end
		
		
		if firstChar >= "A" and firstChar <= "B" and Level1_Key == "AB" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "C" and firstChar <= "D" and Level1_Key == "CD" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "E" and firstChar <= "F" and Level1_Key == "EF" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "G" and firstChar <= "H" and Level1_Key == "GH" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "I" and firstChar <= "J" and Level1_Key == "IJ" then
			UIDropDownMenu_AddButton(menu, level)
		end
	
		if firstChar >= "K" and firstChar <= "L" and Level1_Key == "KL" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "M" and firstChar <= "N" and Level1_Key == "MN" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "O" and firstChar <= "P" and Level1_Key == "OP" then
			UIDropDownMenu_AddButton(menu, level)
		end
	
		if firstChar >= "Q" and firstChar <= "R" and Level1_Key == "QR" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "S" and firstChar <= "T" and Level1_Key == "ST" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "U" and firstChar <= "V" and Level1_Key == "UV" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "W" and firstChar <= "X" and Level1_Key == "WX" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
		if firstChar >= "Y" and firstChar <= "Z" and Level1_Key == "YZ" then
			UIDropDownMenu_AddButton(menu, level)
		end
		
	end
	end
	end

end


function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerPets', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerPets",
		type = 'data source',
		OnTooltipShow = OnTooltipShow,
		OnClick = OnClick,
	})

	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay

	self.initialize = CreateMenu
	self.displayMode = 'MENU'

	UpdateDisplay()
end

parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')